

#import "ChatRoomViewController.h"
#import "AppDelegate.h"
#import "UITextView+Utils.h"
#import "AppConfig.h"
#import "Reachability.h"

@implementation ChatRoomViewController

@synthesize chatRoom;


- (void)activate {
    if ( chatRoom != nil ) {
        chatRoom.delegate = self;
        [chatRoom start];
    }
    
    [input becomeFirstResponder];
}




- (BOOL)connected
{
    Reachability *reachability = [Reachability reachabilityForInternetConnection];
    NetworkStatus networkStatus = [reachability currentReachabilityStatus];
    return !(networkStatus == NotReachable);
}

//Mostrar el mensaje recibido
- (void)displayChatMessage:(NSString*)message fromUser:(NSString*)userName langUser:(NSString *)langMessage{
    //Obtener el idioma de las preferencias
    NSString* user_lang = nil;
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    user_lang = [defaults objectForKey:@"lang_sel"];
    
    
    if(![self connected])
    {
        NSLog(@"no va");
        [chat appendTextAfterLinebreak:[NSString stringWithFormat:@"%@: %@", userName, message]];
        [chat scrollToBottom];
        
    }else if ([[NSUserDefaults standardUserDefaults] boolForKey:@"enabled_translate"]){
        
        NSLog(@"si va");
        
        NSString *urlPath = [NSString stringWithFormat:@"/translate_a/t?client=t&text=%@&langpair=%@|%@",message, langMessage, user_lang];
        
        NSURL *url = [[NSURL alloc] initWithScheme:@"http" host:@"translate.google.com" path:urlPath];
        
        NSMutableURLRequest *request = [[NSMutableURLRequest alloc] init];
        [request setURL:url];
        [request setHTTPMethod:@"GET"];
        
        NSURLResponse *response;
        NSError *error;
        NSData *data;
        data = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];
        NSString *result = [[NSString alloc] initWithData:data encoding:NSASCIIStringEncoding];
        
        NSRange rr2 = [result rangeOfString:@"[[\""];
        NSRange rr3 = [result rangeOfString:@"\","];
        int lengt = rr3.location - rr2.location - rr2.length;
        int location = rr2.location + rr2.length;
        NSRange aa;
        aa.location = location;
        aa.length = lengt;
        result = [result substringWithRange:aa];
        
        [chat appendTextAfterLinebreak:[NSString stringWithFormat:@"%@: %@", userName, result]];
        [chat scrollToBottom];
    }
    
    
    
}



- (void)roomTerminated:(id)room reason:(NSString*)reason {
    
    UIAlertView* alert = [[UIAlertView alloc] initWithTitle:@"Room terminated" message:reason delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil];
    [alert show];
    [self exit];
}



- (IBAction)exit {
    
    [chatRoom stop];
    
    
    [input resignFirstResponder];
    
    
    chat.text = @"";
    
    
    [[ChattyAppDelegate getInstance] showRoomSelection];
}


#pragma mark -
#pragma mark UITextFieldDelegate Method Implementations


- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
	if (theTextField == input) {
        
        [chatRoom broadcastChatMessage:input.text fromUser:[AppConfig getInstance].name langUser:[AppConfig getInstance].lang];
        
        
		[input setText:@""];
	}
	return YES;
}

@end
