

#import "AppDelegate.h"
#import "AppViewController.h"
#import "ChatRoomViewController.h"
#import "WelcomeViewController.h"

static ChattyAppDelegate* _instance;

@implementation ChattyAppDelegate

@synthesize window;
@synthesize viewController;
@synthesize chatRoomViewController;
@synthesize welcomeViewController;

- (void)applicationDidFinishLaunching:(UIApplication *)application {    

    _instance = self;
    
    
    [window addSubview:chatRoomViewController.view];
    [window addSubview:viewController.view];
    [window addSubview:welcomeViewController.view];
    [window makeKeyAndVisible];
    

    [window bringSubviewToFront:welcomeViewController.view];
    [welcomeViewController activate];
}




+ (ChattyAppDelegate*)getInstance {
  return _instance;
}



- (void)showChatRoom:(Room*)room {
  chatRoomViewController.chatRoom = room;
  [chatRoomViewController activate];
  
  [window bringSubviewToFront:chatRoomViewController.view];
}



- (void)showRoomSelection {
  [viewController activate];
  
  [window bringSubviewToFront:viewController.view];
}


@end
