

#import "AppViewController.h"
#import "AppDelegate.h"
#import "LocalRoom.h"
#import "RemoteRoom.h"



@interface ChattyViewController ()
@property(nonatomic,strong) ServerBrowser* serverBrowser;
@end


@implementation ChattyViewController

@synthesize serverBrowser;


- (void)viewDidLoad {
  serverBrowser = [[ServerBrowser alloc] init];
  serverBrowser.delegate = self;
}






- (void)activate {

  [serverBrowser start];
}



- (IBAction)createNewChatRoom:(id)sender {

  [serverBrowser stop];


  LocalRoom* room = [[LocalRoom alloc] init];
  [[ChattyAppDelegate getInstance] showChatRoom:room];
}



- (IBAction)joinChatRoom:(id)sender {

  NSIndexPath* currentRow = [serverList indexPathForSelectedRow];
  if ( currentRow == nil ) {
    UIAlertView* alert = [[UIAlertView alloc] initWithTitle:@"Quina chatroom?" message:@"Si us plau sel·lecciona una chatroom" delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil];
    [alert show];
    return;
  }

  NSNetService* selectedServer = [serverBrowser.servers objectAtIndex:currentRow.row];


  RemoteRoom* room = [[RemoteRoom alloc] initWithNetService:selectedServer];
  

  [serverBrowser stop];
  [[ChattyAppDelegate getInstance] showChatRoom:room];
}


#pragma mark -
#pragma mark ServerBrowserDelegate Method Implementations

- (void)updateServerList {
  [serverList reloadData];
}


#pragma mark -
#pragma mark UITableViewDataSource Method Implementations


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
  return [serverBrowser.servers count];
}



- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
  static NSString* serverListIdentifier = @"serverListIdentifier";

  UITableViewCell *cell = (UITableViewCell *)[tableView dequeueReusableCellWithIdentifier:serverListIdentifier];
	if (cell == nil) {
		cell = [[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:serverListIdentifier];
	}

  
  NSNetService* server = [serverBrowser.servers objectAtIndex:indexPath.row];
  cell.text = [server name];
  
  return cell;
}

@end
