

#import <Foundation/Foundation.h>
#import <CFNetwork/CFSocketStream.h>
#import "ConnectionDelegate.h"


@interface Connection : NSObject {
  id<ConnectionDelegate> delegate;
  

  NSString* host;
  int port;
  

  CFSocketNativeHandle connectedSocketHandle;
  

  NSNetService* netService;
  

  CFReadStreamRef readStream;
  bool readStreamOpen;
  NSMutableData* incomingDataBuffer;
  int packetBodySize;
  

  CFWriteStreamRef writeStream;
  bool writeStreamOpen;
  NSMutableData* outgoingDataBuffer;
}

@property(nonatomic,strong) id<ConnectionDelegate> delegate;


- (id)initWithHostAddress:(NSString*)host andPort:(int)port;


- (id)initWithNativeSocketHandle:(CFSocketNativeHandle)nativeSocketHandle;


- (id)initWithNetService:(NSNetService*)netService;


- (BOOL)connect;


- (void)close;


- (void)sendNetworkPacket:(NSDictionary*)packet;

@end
