

#import "LocalRoom.h"
#import "Connection.h"



@interface LocalRoom ()
@property(nonatomic,strong) Server* server;
@property(nonatomic,strong) NSMutableSet* clients;
@end


@implementation LocalRoom

@synthesize server, clients;


- (id)init {
  clients = [[NSMutableSet alloc] init];
  
  return self;
}






- (BOOL)start {

  server = [[Server alloc] init];
  

  server.delegate = self;
  

  if ( ! [server start] ) {
    self.server = nil;
    return NO;
  }
  
  return YES;
}



- (void)stop {

  [server stop];
  self.server = nil;
  

  [clients makeObjectsPerformSelector:@selector(close)];
}



- (void)broadcastChatMessage:(NSString*)message fromUser:(NSString*)name langUser:(NSString*)lang{

    [delegate displayChatMessage:message fromUser:name langUser:lang];


  NSDictionary* packet = [NSDictionary dictionaryWithObjectsAndKeys:message, @"message", name, @"from", lang, @"mlang", nil];


  [clients makeObjectsPerformSelector:@selector(sendNetworkPacket:) withObject:packet];
}


#pragma mark -
#pragma mark ServerDelegate Method Implementations


- (void) serverFailed:(Server*)server reason:(NSString*)reason {

  [self stop];
  [delegate roomTerminated:self reason:reason];
}



- (void) handleNewConnection:(Connection*)connection {

  connection.delegate = self;
  

  [clients addObject:connection];
}


#pragma mark -
#pragma mark ConnectionDelegate Method Implementations


- (void) connectionAttemptFailed:(Connection*)connection {
}



- (void) connectionTerminated:(Connection*)connection {
  [clients removeObject:connection];
}



- (void) receivedNetworkPacket:(NSDictionary*)packet viaConnection:(Connection*)connection {

    [delegate displayChatMessage:[packet objectForKey:@"message"] fromUser:[packet objectForKey:@"from"] langUser:[packet objectForKey:@"mlang"]];


  [clients makeObjectsPerformSelector:@selector(sendNetworkPacket:) withObject:packet];
}


@end
