
#import "RemoteRoom.h"



@interface RemoteRoom ()
@property(nonatomic,strong) Connection* connection;
@end


@implementation RemoteRoom

@synthesize connection;


- (id)initWithHost:(NSString*)host andPort:(int)port {
  connection = [[Connection alloc] initWithHostAddress:host andPort:port];
  return self;
}



- (id)initWithNetService:(NSNetService*)netService {
  connection = [[Connection alloc] initWithNetService:netService];
  return self;
}






- (BOOL)start {
  if ( connection == nil ) {
    return NO;
  }
  

  connection.delegate = self;
  
  return [connection connect];
}



- (void)stop {
  if ( connection == nil ) {
    return;
  }
  
  [connection close];
  self.connection = nil;
}



- (void)broadcastChatMessage:(NSString*)message fromUser:(NSString*)name langUser:(NSString *)lang{

  NSDictionary* packet = [NSDictionary dictionaryWithObjectsAndKeys:message, @"message", name, @"from", lang, @"mlang", nil];


  [connection sendNetworkPacket:packet];
}


#pragma mark -
#pragma mark ConnectionDelegate Method Implementations

- (void)connectionAttemptFailed:(Connection*)connection {
  [delegate roomTerminated:self reason:@"No es possible connectar amb el servidor"];
}


- (void)connectionTerminated:(Connection*)connection {
  [delegate roomTerminated:self reason:@"Connexió tancada"];
}


- (void)receivedNetworkPacket:(NSDictionary*)packet viaConnection:(Connection*)connection {

  [delegate displayChatMessage:[packet objectForKey:@"message"] fromUser:[packet objectForKey:@"from"] langUser:[packet objectForKey:@"mlang"]];
}


@end
