

#import "ServerBrowserDelegate.h"
#import "ServerBrowser.h"



@interface NSNetService (BrowserViewControllerAdditions)
- (NSComparisonResult) localizedCaseInsensitiveCompareByName:(NSNetService*)aService;
@end

@implementation NSNetService (BrowserViewControllerAdditions)
- (NSComparisonResult) localizedCaseInsensitiveCompareByName:(NSNetService*)aService {
	return [[self name] localizedCaseInsensitiveCompare:[aService name]];
}
@end



@interface ServerBrowser ()


- (void)sortServers;

@end


@implementation ServerBrowser

@synthesize servers;
@synthesize delegate;


- (id)init {
  servers = [[NSMutableArray alloc] init];
  return self;
}






- (BOOL)start {

  if ( netServiceBrowser != nil ) {
    [self stop];
  }

	netServiceBrowser = [[NSNetServiceBrowser alloc] init];
	if( !netServiceBrowser ) {
		return NO;
	}

	netServiceBrowser.delegate = self;
	[netServiceBrowser searchForServicesOfType:@"_chatty._tcp." inDomain:@""];
  
  return YES;
}



- (void)stop {
  if ( netServiceBrowser == nil ) {
    return;
  }
  
  [netServiceBrowser stop];
  netServiceBrowser = nil;
  
  [servers removeAllObjects];
}



- (void)sortServers {
  [servers sortUsingSelector:@selector(localizedCaseInsensitiveCompareByName:)];
}


#pragma mark -
#pragma mark NSNetServiceBrowser Delegate Method Implementations


- (void)netServiceBrowser:(NSNetServiceBrowser *)netServiceBrowser didFindService:(NSNetService *)netService moreComing:(BOOL)moreServicesComing {

  if ( ! [servers containsObject:netService] ) {

    [servers addObject:netService];
  }


  if ( moreServicesComing ) {
    return;
  }
  

  [self sortServers];
  [delegate updateServerList];
}



- (void)netServiceBrowser:(NSNetServiceBrowser *)netServiceBrowser didRemoveService:(NSNetService *)netService moreComing:(BOOL)moreServicesComing {

  [servers removeObject:netService];


  if ( moreServicesComing ) {
    return;
  }
  

  [self sortServers];
  [delegate updateServerList];
}

@end
